<?php
//quellen: IPS-Tasmota, Astronomie-Modul, SymconBTP, tankerkoenig-php-client

require_once __DIR__ . '/../libs/IPSTankerLib.php';

class IPSTankerPreisfinder extends IPSTankerLib
{

    public function Create()
    {
        parent::Create();
        $location = $this->getlocation($this->InstanceID);
        $this->RegisterPropertyFloat('lat', $location['Latitude']);
        $this->RegisterPropertyFloat('lng', $location['Longitude']);
	$this->RegisterPropertyInteger('interval', '15');
        $this->RegisterPropertyFloat('radius', 3.0);
	$this->RegisterPropertyString('TSFavor', '');
	$this->RegisterPropertyString('TSComp', '');
        $this->RegisterPropertyInteger('liter', '60');
        $this->RegisterPropertyString('type', 'e5');
	$this->RegisterVariableString("Name", "Tankstellen (Bester Preis)");
	$this->RegisterVariableFloat("Preis", "Preis (Bester)","Euro");
        $this->RegisterVariableFloat("PreisFavor", "Preis (Tankstelle Favorit)","Euro");
        $this->RegisterVariableFloat("PreisComp", "Preis (Tankstelle Vergleich)","Euro");
        $this->RegisterVariableFloat("TankFavor", "Tank: Füllung bei Favorit","Euro");
        $this->RegisterVariableFloat("DifBester", "Tank: Bester Preis gegenüber Favorit","Euro");
        $this->RegisterVariableFloat("DifComp", "Tank: Vergleich gegenüber Favorit","Euro");

	$this->RegisterTimer('Update', 0, ' TANKERPRICE_Update($_IPS[\'TARGET\'], 0);');
	IPS_SetPosition($this->InstanceID,98);
    }

    public function ApplyChanges()
    {
        parent::ApplyChanges();
        $this->SetTimerInterval('Update', $this->ReadPropertyInteger('interval')* 60 * 1000);

	TANKERPRICE_Update($this->InstanceID);	
    }

   public function Update()
   {
	$UpdateList = IPS_GetInstanceListByModuleID("{60cc7993-2c67-4019-9d4f-309a0ee2dc4f}");

	$PreisFavor = 0;
	$PreisComp = 0;
	$i = 0;
	$set = 0;
        foreach ($UpdateList as $UpdateListID) {
		// Spritsorte
		$MyType = $this->ReadPropertyString('type');
		switch($MyType) {
                case 'e5':
			$TankerID = IPS_GetObjectIDByIdent ("e5",$UpdateList[$i]);
			$Preis = round(GetValueFloat($TankerID),2);
                        break;
		case 'e10':
			$TankerID = IPS_GetObjectIDByIdent ("e10",$UpdateList[$i]);
			$Preis = round(GetValueFloat($TankerID),2);
			break;
		case 'diesel':
			$TankerID = IPS_GetObjectIDByIdent ("diesel",$UpdateList[$i]);
			$Preis = round(GetValueFloat($TankerID),2);
			break;
		}
		// Geöffnet?
		$PreisName = IPS_GetName ( $UpdateList[$i] );
		$TankerID = IPS_GetObjectIDByIdent ("isOpen",$UpdateList[$i]);
		$TankerOpen = GetValueBoolean($TankerID);
		// Standort Koordinaten - Distanz
		$TankerID = IPS_GetObjectIDByIdent ("lat",$UpdateList[$i]);
                $TankerLat = GetValueFloat($TankerID);
		$TankerID = IPS_GetObjectIDByIdent ("lng",$UpdateList[$i]);
                $TankerLong = GetValueFloat($TankerID);
 		$MyLat = $this->ReadPropertyFloat('lat');
                $MyLong = $this->ReadPropertyFloat('lng');
		$MaxDist = $this->ReadPropertyFloat('radius');
		
                $TankerID = IPS_GetObjectIDByIdent ("ID",$UpdateList[$i]);
                $StationID = GetValueString($TankerID);
		$dist = $this->getdistance($MyLat, $MyLong, $TankerLat, $TankerLong, 'K');

		// Favorit
		$MyFav = $this->ReadPropertyString('TSFavor');
		if ($MyFav == $StationID){
			$TankerID = IPS_GetObjectIDByIdent ("PreisFavor",$this->InstanceID);
        		SetValueFloat($TankerID, $Preis);
			$PreisFavor = $Preis;
		}
		// Vergleich
		$MyComp = $this->ReadPropertyString('TSComp');
                if ($MyComp == $StationID){
                        $TankerID = IPS_GetObjectIDByIdent ("PreisComp",$this->InstanceID);
                        SetValueFloat($TankerID, $Preis);
			$PreisComp = $Preis;
                }


		if (($TankerOpen == 1)and($dist <= $MaxDist)){
			if ($set == 0){
				$BesterPreis = $Preis;
				$BesterPreisName = $PreisName;
				$set = 1;
			}
			else{
				if ($Preis == $BesterPreis){
					$BesterPreisName = $BesterPreisName.",".$PreisName;
				}
				if ($Preis < $BesterPreis){
					$BesterPreis = $Preis;
					$BesterPreisName = $PreisName;
				}
			}
		}
            	$i++;
        }

	
	
	$MyLiter = $this->ReadPropertyInteger('liter');
	//Tankfüllung
        $TankerID = IPS_GetObjectIDByIdent ("TankFavor",$this->InstanceID);
        SetValueFloat($TankerID, ($PreisFavor*$MyLiter));

        $TankerID = IPS_GetObjectIDByIdent ("DifBester",$this->InstanceID);
        SetValueFloat($TankerID, (($BesterPreis - $PreisFavor )*$MyLiter));

        $TankerID = IPS_GetObjectIDByIdent ("DifComp",$this->InstanceID);
        SetValueFloat($TankerID, (($PreisComp - $PreisFavor )*$MyLiter));

        $TankerID = IPS_GetObjectIDByIdent ("Name",$this->InstanceID);
        SetValueString($TankerID, $BesterPreisName);
        $TankerID = IPS_GetObjectIDByIdent ("Preis",$this->InstanceID);
        SetValueFloat($TankerID, $BesterPreis);

   }

}
