<?php
//quellen: IPS-Tasmota, Astronomie-Modul, SymconBTP, tankerkoenig-php-client
require_once __DIR__ . '/../libs/IPSTankerLib.php';

class IPSTankerUpdater extends IPSTankerLib
{

    public function Create()
    {
        parent::Create();
	$this->RegisterPropertyInteger('interval', '15');
	$this->RegisterTimer('Update', 0, ' TANKERUPD_Update($_IPS[\'TARGET\'], 0);');
	if (count(IPS_GetInstanceListByModuleID("{a4c81849-cc5d-4719-bec0-319f4691856b}")) > 1){
		echo "Updater darf nur einmal Installiert werden!";
	}
	IPS_SetPosition($this->InstanceID,99);  
    }

    public function ApplyChanges()
    {
        parent::ApplyChanges();
	if ($this->ReadPropertyInteger('interval')<10){
		echo "Laut Nutzungsbedingungen der Tankerkönig API ist eine Abfrage nur alle 5 Minuten erlaubt und alle 10 Minuten empfohlen!";
	}
        $this->SetTimerInterval('Update', $this->ReadPropertyInteger('interval')* 60 * 1000);

	TANKERUPD_Update($this->InstanceID);	
    }

public function Update()
   {
$APIKey = $this->getapikey($this->InstanceID);
$UpdateList = IPS_GetInstanceListByModuleID("{60cc7993-2c67-4019-9d4f-309a0ee2dc4f}");
$UpdateCount = count($UpdateList);

$i = 0;
        foreach ($UpdateList as $UpdateListID) {
			$TankerID = IPS_GetObjectIDByIdent ("ID",$UpdateList[$i]);
			$TankerID = GetValueString($TankerID);
			if ($i == 0){
				$TankerString = $TankerID;
			}
			else{
				$TankerString = $TankerString.",".$TankerID;
			}
            $i++;
        }
$result = json_decode(file_get_contents("https://creativecommons.tankerkoenig.de/json/prices.php?ids=$TankerString&apikey=$APIKey"));

$i = 0;
        foreach ($UpdateList as $UpdateListID) {
			
			$TankerID = IPS_GetObjectIDByIdent ("ID",$UpdateList[$i]); 
			$TankstelleID = GetValueString($TankerID); 
			$result_array = $result->prices->$TankstelleID; 
        	$TankerID = IPS_GetObjectIDByIdent ("isOpen",$UpdateList[$i]);
        	if ($result_array->status == "open"){
                SetValueBoolean($TankerID, 1);
        	}
        	else {
                SetValueBoolean($TankerID,0 );
        	}
		    if (property_exists($result_array, 'e5')){
				$TankerID = IPS_GetObjectIDByIdent ("e5",$UpdateList[$i]);
				SetValueFloat($TankerID,$result_array->e5 );
			}
			if (property_exists($result_array, 'e10')){
				$TankerID = IPS_GetObjectIDByIdent ("e10",$UpdateList[$i]);
				SetValueFloat($TankerID,$result_array->e10 );
			}
			if (property_exists($result_array, 'diesel')){
				$TankerID = IPS_GetObjectIDByIdent ("diesel",$UpdateList[$i]);
				SetValueFloat($TankerID,$result_array->diesel );
			}
            $i++;
        }

   }
}
