<?php
class IPSTankerLib extends IPSModule
   {

public function GetIPSVersion()
    {
        $ipsversion = floatval(IPS_GetKernelVersion());
        if ($ipsversion < 4.1) // 4.0
        {
            $ipsversion = 0;
        } elseif ($ipsversion >= 4.1 && $ipsversion < 4.2) // 4.1
        {
            $ipsversion = 1;
        } elseif ($ipsversion >= 4.2 && $ipsversion < 4.3) // 4.2
        {
            $ipsversion = 2;
        } elseif ($ipsversion >= 4.3 && $ipsversion < 4.4) // 4.3
        {
            $ipsversion = 3;
        } elseif ($ipsversion >= 4.4 && $ipsversion < 5) // 4.4
        {
            $ipsversion = 4;
        } else   // 5
        {
            $ipsversion = 5;
        }
        return $ipsversion;
    }

public function getlocation()
    {
        $LocationID = IPS_GetInstanceListByModuleID("{45E97A63-F870-408A-B259-2933F7EABF74}")[0];
        $InstanceStat = IPS_GetInstance($LocationID)['InstanceStatus'];

        if ($InstanceStat == 102){
        $ipsversion = $this->GetIPSVersion($this->InstanceID);
                if ($ipsversion == 5) {
                        $Location = json_decode(IPS_GetProperty($LocationID, "Location"));
                        $Latitude = $Location->latitude;
                        $Longitude = $Location->longitude;
                } else {
                        $Latitude = IPS_GetProperty($LocationID, "Latitude");
                        $Longitude = IPS_GetProperty($LocationID, "Longitude");
                }
                $location = array("Latitude" => $Latitude, "Longitude" => $Longitude);
                return $location;
        }
    }


public function getapikey()
    {
        $ConfigID = IPS_GetInstanceListByModuleID("{fb0ed1f6-7e7b-47b2-815d-c1a2485c38c8}")[0];
        $apikey = IPS_GetProperty($ConfigID, "APIKey");
        return $apikey;
    }


/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/*::                                                                         :*/
/*::  This routine calculates the distance between two points (given the     :*/
/*::  latitude/longitude of those points). It is being used to calculate     :*/
/*::  the distance between two locations using GeoDataSource(TM) Products    :*/
/*::                                                                         :*/
/*::  Definitions:                                                           :*/
/*::    South latitudes are negative, east longitudes are positive           :*/
/*::                                                                         :*/
/*::  Passed to function:                                                    :*/
/*::    lat1, lon1 = Latitude and Longitude of point 1 (in decimal degrees)  :*/
/*::    lat2, lon2 = Latitude and Longitude of point 2 (in decimal degrees)  :*/
/*::    unit = the unit you desire for results                               :*/
/*::           where: 'M' is statute miles (default)                         :*/
/*::                  'K' is kilometers                                      :*/
/*::                  'N' is nautical miles                                  :*/
/*::  Worldwide cities and other features databases with latitude longitude  :*/
/*::  are available at https://www.geodatasource.com                         :*/
/*::                                                                         :*/
/*::  For enquiries, please contact sales@geodatasource.com                  :*/
/*::                                                                         :*/
/*::  Official Web site: https://www.geodatasource.com                       :*/
/*::                                                                         :*/
/*::         GeoDataSource.com (C) All Rights Reserved 2017                  :*/
/*::                                                                         :*/
/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

  public function getdistance(float $lat1, float $lon1, float $lat2, float $lon2, string $unit) {

        $theta = $lon1 - $lon2;
        $dist = sin(deg2rad($lat1)) * sin(deg2rad($lat2)) +  cos(deg2rad($lat1)) * cos(deg2rad($lat2)) * cos(deg2rad($theta));
        $dist = acos($dist);
        $dist = rad2deg($dist);
        $miles = $dist * 60 * 1.1515;
        $unit = strtoupper($unit);
        if ($unit == "K") {
                return round(($miles * 1.609344),2);
        } else if ($unit == "N") {
                return round(($miles * 0.8684),2);
        } else {
                return round($miles,2);
        }
  }



   }
?>
